Bug 387582 - Window List lacks keyboard usability
Summary: Window List lacks keyboard usability
Status: RESOLVED FIXED
Alias: None
Product: plasmashell
Classification: Unclassified
Component: Window List (show other bugs)
Version: 5.8.6
Platform: Debian stable Linux
: NOR normal
Target Milestone: 1.0
Assignee: Plasma Bugs List
URL:
Keywords: usability
Depends on:
Blocks:
 
Reported: 2017-12-04 13:19 UTC by Juanma
Modified: 2022-04-03 17:57 UTC (History)
4 users (show)

See Also:
Latest Commit:
Version Fixed In:


Attachments
Keyboard operation, as is (1.47 MB, video/mp4)
2019-03-05 16:49 UTC, andydecleyre
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Juanma 2017-12-04 13:19:18 UTC
The Window List plasma widget which has replaced the good old pop-up window cannot really be used without pointing device: it is possible to open the widget with an assigned shortcut, and close it again with the same shortcut (not with Esc), but it is not possible to select a window or actually anything at all with keyboard only.

Before (I think up until KDE 4.x, but I'm not sure) it was possible to open the Window List with its shortcut (like now) and then:
- select any window in the list with keyboard arrows
- and press Enter to switch to it
- or press the contextual menu button (if your keyboard has one) to get a helpful pop-up menu
- or press Esc to close the Window List

None of those 4 actions is possible anymore.
Comment 1 Juanma 2017-12-05 19:40:39 UTC
Let me correct myself: it is possible to get keyboard focus on the window list per se, after 3 tab skips, and so it is possible to select a window and press Enter to switch to it.

The rest is as I described before.

It is worth mentioning that the pin icon of the widget gets focus before the list itself. I can't find much use for that pin, because pinning the widget makes it stay above all other windows. On the other hand, it is not possible to make the widget stay put but not cover other windows, so the whole pinning thing usefulness is outside my current scope of understanding.
Comment 2 andydecleyre 2019-03-04 20:03:46 UTC
I've got plasma-desktop 5.15.2 here, and the actions you list as 1, 2, and 4 seem to work perfectly. I've remapped my context menu button and can't conveniently test 3.
Comment 3 Juanma 2019-03-04 21:59:54 UTC
(In reply to andydecleyre from comment #2)
> I've got plasma-desktop 5.15.2 here, and the actions you list as 1, 2, and 4
> seem to work perfectly.

To make it clear: can you execute the following steps without any TAB-skipping in between?
- open the Window List widget by pressing its associated keyboard shortcut
- select a window in the list using only the keyboard (presumably with arrow keys)
- switch to that window (presumably with Enter key) or close the List with the Esc key

Again, just to make sure we speak the same lingo: with "TAB-skipping" I mean pressing the Tab key on the keyboard, one or more times, to shift the focus over different elements in the screen.
Comment 4 andydecleyre 2019-03-05 16:49:07 UTC
Created attachment 118578 [details]
Keyboard operation, as is

Yes, and no -- I was mistaken. It all works *except* the window does not gain focus, it is only raised. This bug is still valid. I'm attaching a video.

Oh, I probably should have mentioned, I'm using/testing-with latte dock rather than a plain panel.
Comment 5 Nate Graham 2022-04-03 17:57:11 UTC
Git commit 48a0fc3719de3a87c394af905b16f8cedb9b6c08 by Nate Graham, on behalf of Jan Blackquill.
Committed on 03/04/2022 at 17:49.
Pushed by ngraham into branch 'master'.

applets/windowlist: rewrite

This rewrites the Window List applet, in order to
have simpler code, as well as having a more useful
design that tells the user what app is in focus.
Related: bug 405087

A  +74   -0    applets/window-list/contents/ui/MenuButton.qml     [License: GPL(v2.0+)]
M  +64   -242  applets/window-list/contents/ui/main.qml

https://invent.kde.org/plasma/plasma-desktop/commit/48a0fc3719de3a87c394af905b16f8cedb9b6c08